/*! copyright cloudtechcredit.com */
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 5);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _ajax = __webpack_require__(1);

var _ajax2 = _interopRequireDefault(_ajax);

var _params = __webpack_require__(2);

var _params2 = _interopRequireDefault(_params);

var _extend = __webpack_require__(3);

var _extend2 = _interopRequireDefault(_extend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*日志存储接口*/
var logUrl = "https://app.chinacreditech.com/gateway/attachment/log"; /**
                                                                       * Created by long on 2018/1/10.
                                                                       */


var _log = {
    params: new _params2.default(),
    sendParams: {},
    submit: true,
    url: "",
    initFun: function initFun() {},
    init: function init() {
        this.initFun.call(this);
    },
    trace: function trace(p, type, sid) {
        /*metric*/
        p = p || {};
        var g = {};
        g.type = type || "METRIC_MSG";
        g.metric = p;
        this.extend(g, sid);
        this.send();
    },
    inter: function inter(p, sid) {
        /*servicePerformance*/
        p = p || {};
        var g = {};
        g.type = "BU_MSG";
        g.servicePerformance = p;
        this.extend(g, sid);
        this.send();
    },
    view: function view(p, sid) {
        /*metric*/
        p = p || {};
        var g = {};
        g.type = "VIEW_PAGE";
        g.metric = p;
        this.extend(g, sid);
        this.send();
    },
    error: function error(p, sid) {
        /*error*/
        p = p || {};
        var g = {};
        g.type = "ERROR_MSG";
        g.error = p;
        this.extend(g, sid);
        this.send();
    },
    setGlobal: function setGlobal(p, s) {
        if (s) this.submit = true;
        this.params = (0, _extend2.default)(this.params, p);
    },
    setInit: function setInit(fun) {
        if (typeof fun == "function") {
            this.initFun = fun;
        }
    },
    setSource: function setSource(sid, pid) {
        var source = {
            logType: this.params.type,
            source: this.params.cs_app,
            traceId: this.uuid(),
            spanId: sid,
            parentSpanId: pid
        };
        this.params.logSource = (0, _extend2.default)(this.params.logSource, source);
    },
    send: function send() {
        this.sendParams.createTime = new Date().getTime();
        // !this.submit && console.log(this.sendParams)
        this.submit && (0, _ajax2.default)({
            url: this.url,
            type: "POST",
            data: this.sendParams,
            dataType: "json",
            success: function success(response, xml) {},
            fail: function fail(status) {}
        });
    },
    extend: function extend(p, sid) {
        this.sendParams = (0, _extend2.default)(new _params2.default(), this.params, p);
        this.setSource(sid);
    },
    uuid: function uuid() {
        var s = [];
        var hexDigits = "0123456789abcdef";
        for (var i = 0; i < 36; i++) {
            s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
        }
        s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
        s[19] = hexDigits.substr(s[19] & 0x3 | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
        s[8] = s[13] = s[18] = s[23] = "-";

        var uuid = s.join("");
        return uuid;
    }
};

exports.default = _log;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
/**
 * Created by long on 2018/1/5.
 */
var ajax = function ajax(options) {
    options = options || {};
    options.type = (options.type || "GET").toUpperCase();
    options.dataType = options.dataType || "json";
    var params = JSON.stringify(options.data);

    //创建 - 非IE6
    if (window.XMLHttpRequest) {
        var xhr = new XMLHttpRequest();
    } else {
        //IE6及其以下版本浏览器
        var xhr = new ActiveXObject('Microsoft.XMLHTTP');
    }

    //接收
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4) {
            var status = xhr.status;
            if (status >= 200 && status < 300) {
                options.success && options.success(xhr.responseText, xhr.responseXML);
            } else {
                options.fail && options.fail(status);
            }
        }
    };

    //连接 和 发送
    if (options.type == "GET") {
        xhr.open("GET", options.url + "?" + encodeURIComponent(params), true);
        xhr.send(null);
    } else if (options.type == "POST") {
        xhr.open("POST", options.url, true);
        xhr.setRequestHeader("Content-Type", "application/json;charset=utf-8");
        xhr.send(params);
    }
};

exports.default = ajax;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
/**
 * Created by long on 2018/1/8.
 */
var params = function params() {
    var u = navigator.userAgent;
    var os = u.indexOf('Android') > -1 ? 'android' : u.indexOf('iPhone') > -1 ? 'iPhone' : 'other';
    return {
        type: "" /*类型:ERROR_MSG|BU_MSG|METRIC_MSG|APP_BP_MSG|LOCATION_MSG*/
        , createTime: new Date().getTime(),
        cs_app: "" /* 主体标识，如CH_H5 */
        , ipAddress: "",
        other: {
            windowInnerWidth: window.innerWidth,
            windowInnerHeight: window.innerHeight,
            windowScreenAvailWidth: window.screen.availWidth,
            windowScreenAvailHeight: window.screen.availHeight,
            windowDevicePixelRatio: window.devicePixelRatio,
            windowApplicationCache: {},
            businessNo: "",
            productName: "",
            ext: ""
        },
        userInfo: {
            /*设备相关*/
            userGPS: "" /*用户GPS信息*/
            , mobileModel: "" /*设备型号*/
            , os_version: os /*操作系统*/
            , userDevId: "" /*设备唯一ID*/
            , mobileBrand: "" /*手机品牌*/
            , network: "" /*运营商*/
            , networkType: "" /*网络类型*/
            , userAgent: u

            /*位置信息*/
            , country: "" /*国家*/
            , province: "" /*省份*/
            , city: "" /*城市*/
            , district: "" /*区域*/
            , address: "" /*地址*/
            , latitude: "" /*纬度*/
            , locationErrorCode: "" /*位置错误码*/
            , longitude: "" /*经度*/

            /*用户信息*/
            , userName: "",
            userId: "",
            userType: "",
            mobileNo: "",
            appVersion: "",
            idFintechUmUser: "",
            customerManagerName: "",
            customerManagerMobileNo: "",
            cityName: "",
            channelName: "",
            deptName: "",
            teamLeader: "",
            secondManager: "",
            firstManager: ""

        },
        servicePerformance: {
            req: {} /*请求-对象*/
            , resp: {} /*应答*/
            , retCode: "" /*状态*/
            , reqTime: 0 /*请求时间*/
            , respTime: 0 /*应答时间*/
            , duration: 0 /*处理耗时*/
            , apiType: "" /*接口类型*/
            , serviceName: "" /*服务或页面名称*/
            , uri: {} /*服务uri*/
            , APIName: "" /*服务API名称*/
            , hostName: "" /*主机名*/
            , serverIp: "" /*主机IP*/
        },
        metric: {
            functionName: "" /*功能名*/
            , currentPage: "" /*当前页面*/
            , prePage: "" /*上一页面*/
            , uri: {}
            // option:'',
            // state:'succ|fail'
            // succ:'funcstring',
            // fail:'funcstring'
            /*uri*/
            , startTime: 0 /*应用启动时间*/
            , endTime: 0 /*应用退出时间*/
            , installTIme: 0 /*安装时间*/
        },
        logSource: {
            logType: "" /*日志类型*/
            , source: "" /*日志来源*/
            , traceId: "" /*整个请求调用链唯一标识*/
            , spanId: "" /*单个服务内部唯一标识*/
            , parentSpanId: "" /*当前调用服务上游Id*/
        },
        error: {
            error_msg: "" /*错误信息*/
            , reqTime: 0 /*请求时间*/
            , businessNo: "" /*loan_id*/
            , hostName: "" /*主机名*/
            , req: {} /*调用入参*/
            , uri: {}
        }
    };
};

exports.default = params;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/**
 * Created by long on 2018/1/10.
 */

function cloneObj(oldObj) {
  if ((typeof oldObj === "undefined" ? "undefined" : _typeof(oldObj)) != 'object') return oldObj;
  if (oldObj === null) return oldObj;
  if (Object.prototype.toString.call(oldObj) === "[object Array]") {
    var newObj = [];
    for (var i = 0; i < oldObj.length; i++) {
      newObj[i] = cloneObj(oldObj[i]);
    }
    return newObj;
  } else {
    var newObj = new Object();
    for (var i in oldObj) {
      if (oldObj.hasOwnProperty(i)) newObj[i] = cloneObj(oldObj[i]);
    }
    return newObj;
  }
};
function extend() {
  var args = arguments;
  if (args.length < 2) return;
  var temp = cloneObj(args[0]);
  for (var n = 1; n < args.length; n++) {
    for (var i in args[n]) {
      if (args[n][i] !== null) {
        if (_typeof(args[n][i]) == "object") {
          if (Object.prototype.toString.call(args[n][i]) === "[object Array]") {
            temp[i] = extend(temp[i] ? temp[i] : [], args[n][i]);
          } else {
            temp[i] = extend(temp[i] ? temp[i] : {}, args[n][i]);
          }
        } else {
          temp[i] = args[n][i];
        }
      }
    }
  }
  return temp;
}
exports.default = extend;

/***/ }),
/* 4 */,
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _method = __webpack_require__(0);

var _method2 = _interopRequireDefault(_method);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*日志存储接口*/
var logUrl = "https://metric.chinacreditech.com/metric/attachment/log"; /**
                                                                         * Created by long on 2018/1/4.
                                                                         */

window.fjTrace = _method2.default;
window.fjTrace.url = logUrl;

/* 事件监听 */
/* 页面加载完成 */
window.addEventListener("load", function (e) {
    var o = {
        functionName: "view",
        currentPage: location.href,
        prePage: document.referrer
    };
    fjTrace.init();
    fjTrace.view(o);
}, false);

window.addEventListener("hashchange", function (e) {
    var o = {
        functionName: "view",
        currentPage: e.newURL,
        prePage: e.oldURL
    };
    fjTrace.view(o);
}, false);

window.addEventListener("error", function (e) {
    var o = {
        error_msg: e.message,
        reqTime: "",
        businessNo: "",
        req: { msg: e.error.message, stack: e.error.stack },
        uri: {
            url: location.href,
            referrer: document.referrer
        }
    };
    fjTrace.error(o);
}, false);

/***/ })
/******/ ]);